<template>
  <MSelect
    placeholder="Rechercher"
    orientation="vertical"
    :main-design="'outlined'"
    v-model="d_value"
    error-message="Field required"
    :option-value="opt => opt === null ? null : opt.id"
    :option-label="opt => opt === null ? '- Null -' : opt.label"
    :usingInput="true"
    :customOption="true"
    :chips="true"
    :multiple="true"
    m-drop-down-icon="ion-search"
    v-on:on-filter="onFilter"
    dynamic-slot-selected-item="selected-item"
    :options="filterOptions"
    @m-add="onAdd"
  >

    <template v-slot:before-options>

    </template>

    <template v-slot:mSelectedItem="{scope}">
      <q-chip
        v-if="_.isObject(scope.opt) && scope.opt.visibleInput"
        dense
        square
        :tabindex="scope.tabindex"
        color="white"
        text-color="black"
        class="q-ma-xs">
        <q-btn-group dense >
          <q-btn size="sm" color="primary" :label="scope.opt.label"/>
          <q-btn size="sm" outline text-color="black"
                 @click="scope.removeAtIndex(scope.index)">
            <div class="row items-center no-wrap">
              <div class="text-center">
                <template v-if="Array.isArray(scope.opt.value)">
                  <template v-for="(item, index) in scope.opt.value">
                    {{ item }}&nbsp;
                    <span :key="index" class="text-grey-8 text-lowercase">
                            {{ index !== scope.opt.value.length -1 ? ' ou ' : ''}}
                          </span>
                  </template>
                </template>
                <template v-else>
                  {{scope.opt.value }}
                </template>
              </div>
              <q-icon right name="cancel"/>
            </div>
          </q-btn>
        </q-btn-group>
      </q-chip>
    </template>

    <template v-slot:mOption="{scope}">
      <q-item dense v-bind="scope.itemProps" v-on="scope.itemEvents">
        <q-item-section>
          <q-item-label caption>
            Rechercher
            <span class="text-weight-bolder">{{ scope.opt.value}}</span>
            dans
            <span class="text-italic">{{ scope.opt.label }}</span>
          </q-item-label>
        </q-item-section>
      </q-item>
    </template>

  </MSelect>

  <!--  </div>-->
</template>

<script>
  import MSelect from '../forms/MSelect'
  import _ from 'lodash'
  // import Builder from '../../plugins/filters'

  export default {
    name: 'MSearchTable',

    components: {MSelect},

    /*model: {
      prop: 'value',
      event: 'input',
    },*/

    props: {
      value: {
        type: [Array, String, Object],
      },
      columns: {
        type: Array,
      },
    },
    data() {
      return {
        d_value: [],//this.value.filter(v => this._.isObject(v)),
        options: [],
        filterOptions: [],
        invisibleOptions: [],
      }
    },

    methods: {
      onFilter(val, update, abort) {
        if (val.length < 1) {
          abort()
          return
        }
        update(() => {
          const needle = val
          this.filterOptions = []
          if (!_.isObject(needle)) {
            this.options.forEach(v => {
              this.filterOptions.push({
                id: v.id,
                field: v.id,
                label: v.label,
                operand: v.operand,
                value: needle,
                visibleInput: v.visibleInput,
                type: v.type,
              })
            })
          } else {
          }
        })
      },

      onAdd(details) {
        // console.warn('details ', details)
        if (details.value.type === 'number') {
          details.value.operand = 'equals'
          details.value.value = Number(details.value.value)
        }
      },
    },

    computed: {
      searchText: {
        get: function () {
          // eslint-disable-next-line vue/no-side-effects-in-computed-properties
          return this.d_value = this.value
        },
        set: function (v) {
          this.d_value = v
        },
      },
    },

    watch: {
      value: {
        handler: function (val, oldVal) {
          this.d_value = val
        },
        deep: true,
        immediate: true,
      },
      d_value: {
        handler: function (val, oldVal) {
          if (!this._.isEqual(val, oldVal)) {
            if (!val || !oldVal) {
              this.$emit('input', val)
              return
            }
            if (val.length < oldVal.length) {
              // its deletion
              let found = oldVal.filter(d => !val.includes(d))[0]
              let foundIndex = this._.findIndex(oldVal, found)
              if (foundIndex === 0) val.splice(foundIndex, 1)
              else val.splice(foundIndex - 1, 1)
            } else if (val.length >= oldVal.length) { //its addition
              if (oldVal.length !== 0 && val[val.length - 1] !== 'and') {
                let lastV = val.pop()
                val.push('and', lastV)
              }
            }
            this.$emit('input', val)
          }
        },
        deep: true,
      },
    },

    mounted() {
      // console.log('Builder', Builder)
      if (this.columns) {
        this.options = this.columns
          .map(v => {
            return {
              id: v.name,
              field: v.name,
              label: v.label,
              operand: 'contains',
              value: null,
              visibleInput: true,
              type: v.type,
            }
          })
      }
    },
  }
</script>
